/*	
 *	clipcosp.h
 *
 *	FԃCu
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2013 Naoyuki Sawa
 *
 *	* Sun Jun 02 14:32:55 JST 2013 Naoyuki Sawa
 *	- 1st [XB
 *	- P/ECEɃJ[\͂܂񂪁AIȌvZɗpAc[ŗp邽߂ɗpӂ܂B
 */
#ifndef __CLIP_COSP_H__
#define __CLIP_COSP_H__

/****************************************************************************
 *	HSVF
 ****************************************************************************/

//HSVFԂ̒` (QlURL:http://ja.wikipedia.org/wiki/HSVF)
//
//	F(Hue)        [0.0,1.0)
//	ʓx(Saturation) [0.0,1.0]
//	x(Value)      [0.0,1.0]
//
//	@@@H=0/6`1/6
//	@@@H=1/6`2/6
//	@@@H=2/6`3/6
//	@@@H=3/6`4/6
//	@@@H=4/6`5/6
//	@@@H=5/6`6/6
//	
//	qP_QQ^P
//	
//	f^PP_QQ
//	
//	aQQ^PP_
//	

/*--------------------------------------------------------------------------*/

/* RGBHSV֕ϊ܂B
 * [in]
 *	rgb[0]	[0.0,1.0]	0.00.0ɁC1.0߂1.0ɕ␳܂B
 *	rgb[1]	[0.0,1.0]	0.00.0ɁC1.0߂1.0ɕ␳܂B
 *	rgb[2]	[0.0,1.0]	0.00.0ɁC1.0߂1.0ɕ␳܂B
 * [out]
 *	hsv[0]	F[0.0,1.0)
 *	hsv[1]	ʓx[0.0,1.0]
 *	hsv[2]	x[0.0,1.0]
 * [note]
 *	- rgb[]hsv[]̓GAXZ[tłAdȂ郁̈w\łB
 */
void RGBtoHSV(const double rgb[3], double hsv[3]);

/*--------------------------------------------------------------------------*/

/* RGBHSV֕ϊ܂B
 * [in]
 *	hsv[0]	F[0.0,1.0)	0.0,y,1.0ȏ́A[0.0,1.0)͈̔͂Ɋۂ߂܂B
 *	hsv[1]	ʓx[0.0,1.0]	0.00.0ɁC1.0߂1.0ɕ␳܂B
 *	hsv[2]	x[0.0,1.0]	0.00.0ɁC1.0߂1.0ɕ␳܂B
 * [out]
 *	rgb[0]	[0.0,1.0]
 *	rgb[1]	[0.0,1.0]
 *	rgb[2]	[0.0,1.0]
 * [note]
 *	- hsv[]rgb[]̓GAXZ[tłAdȂ郁̈w\łB
 */
void HSVtoRGB(const double hsv[3], double rgb[3]);

#endif /*__CLIP_COSP_H__*/
